'######################## Dialog Builder Template #########################

    #INCLUDE "editbox.inc"

'##########################################################################

FUNCTION WinMain(ByVal Instance      as LONG, _
                 ByVal hPrevInstance as LONG, _
                 lpszCmdLine         as ASCIIZ PTR, _
                 ByVal nCmdShow      as LONG) AS LONG

    hInstance = Instance

    DialogBox hInstance,ByVal 100,0,CodePtr(DlgProc1)

    FUNCTION = 0

END FUNCTION

'##########################################################################

FUNCTION DlgProc1(ByVal hDlg   as LONG, _
                  ByVal Msg    as LONG, _
                  ByVal wParam as LONG, _
                  ByVal lParam as LONG) EXPORT as LONG

  LOCAL Caption as ASCIIZ * 20  ' make larger if needed

  Select Case Msg

      Case %WM_INITDIALOG

        hWnd = hDlg     ' hWnd is global handle

        SendMessage hDlg,%WM_SETICON,1, _
                    LoadIcon(hInstance,ByVal 1)

        Caption="Your Dialog App"
          SendMessage hDlg,%WM_SETTEXT,0,VarPtr(Caption)

        ' ----------------------------
        ' Get handles for dialog items
        ' ----------------------------
          h1Edit1        = GetDlgItem(hDlg,101)
          h1Button1      = GetDlgItem(hDlg,102)
          h1Static1      = GetDlgItem(hDlg,103)

          SetText h1Static1,"Unmodified Text"
          SetText h1Edit1,"Modified Text !"

      Case %WM_COMMAND
        Select Case wParam
          Case 102    ' "Change Text"
            txt$ = GetText(h1Edit1)
            SetText h1Static1,txt$

        End Select

      Case %WM_CLOSE
         EndDialog hDlg, 0

  END Select

END FUNCTION

'##########################################################################

SUB SetText(hndle as LONG,txt as STRING)

  SendMessage hndle, %WM_SETTEXT, 0, StrPtr(txt)

END SUB

'##########################################################################

FUNCTION GetText(hndle as LONG) as STRING

    LOCAL tl as LONG
    LOCAL Buffer as STRING

    tl=GetWindowTextLength(hndle)
    Buffer=space$(tl+1)
    GetWindowText hndle,ByVal strptr(Buffer),tl+1

    FUNCTION = left$(Buffer,len(Buffer)-1)

END FUNCTION

'##########################################################################

