'######################## Dialog Builder Template #########################

    #INCLUDE "listbox.inc"

'##########################################################################

FUNCTION WinMain(ByVal Instance      as LONG, _
                 ByVal hPrevInstance as LONG, _
                 lpszCmdLine         as ASCIIZ PTR, _
                 ByVal nCmdShow      as LONG) AS LONG

    hInstance = Instance

    DialogBox hInstance,ByVal 100,0,CodePtr(DlgProc1)

    FUNCTION = 0

END FUNCTION

'##########################################################################

FUNCTION DlgProc1(ByVal hDlg   as LONG, _
                  ByVal Msg    as LONG, _
                  ByVal wParam as LONG, _
                  ByVal lParam as LONG) EXPORT as LONG

  LOCAL Caption as ASCIIZ * 20  ' make larger if needed

  Select Case Msg

      Case %WM_INITDIALOG

        hWnd = hDlg     ' hWnd is global handle

        SendMessage hDlg,%WM_SETICON,1, _
                    LoadIcon(hInstance,ByVal 1)

        Caption="List Box Test"
          SendMessage hDlg,%WM_SETTEXT,0,VarPtr(Caption)

        ' ----------------------------
        ' Get handles for dialog items
        ' ----------------------------
          h1ListBox1     = GetDlgItem(hDlg,101)
          lpListProc1& =SetWindowLong(h1ListBox1,%GWL_WNDPROC,_
                                      ByVal CodePtr(ListProc1))

          h1Static1      = GetDlgItem(hDlg,102)
          h1Button1      = GetDlgItem(hDlg,103)

        ' ------------------------------
        ' Put some items in the list box
        ' ------------------------------
          Data Item 1
          Data Item 2
          Data Item 3
          Data Item 4
          Data Item 5
          Data Item 6
          Data Item 7
          Data Item 8
          Data Item 9
          Data Item 10
          Data Item 11
          Data Item 12
          Data Item 13
          Data Item 14
          Data Item 15
          Data Item 16
          Data Item 17
          Data Item 18
          Data Item 19
          Data Item 20

          number& = DATACOUNT

          rf& = 1

          Do
            x$=read$(rf&)
            SendMessage h1ListBox1,%LB_ADDSTRING,0,ByVal StrPtr(x$)
            ! inc rf&
            If rf& > number& Then Exit Do
          Loop

      Case %WM_COMMAND
        Select Case wParam
          Case 103    ' "Close"
            ! jmp Outa_Here

        End Select

      Case %WM_CLOSE
        Outa_Here:
        EndDialog hDlg, 0

  END Select

END FUNCTION

'##########################################################################

FUNCTION ListProc1(BYVAL hCtl   as LONG, _
                   BYVAL Msg    as LONG, _
                   BYVAL wParam as LONG, _
                   BYVAL lParam as LONG) EXPORT AS LONG

    Select Case Msg
      Case %WM_LBUTTONDBLCLK
      ' ------------------------------------------------
      ' Get the index of the selected item, get the text
      ' at that index in the listbox and then display it
      ' ------------------------------------------------
        cSel& = SendMessage(h1ListBox1,%LB_GETCURSEL,0,0)

        Buffer$ = space$(32)
        SendMessage h1ListBox1,%LB_GETTEXT,cSel&,ByVal StrPtr(Buffer$)

        MessageBox hWnd,ByCopy Buffer$, _
                   "SubClassed List Box",%MB_ICONINFORMATION

    End Select

  FUNCTION=CallWindowProc(ByVal lpListProc1&,hCtl,Msg,wParam,lParam)

END FUNCTION

' ##########################################################################

